define(['bridge', 'translate', 'jquery', 'jqueryui', 'dialogbuttoneditor'], function (Bridge, Translate, $, _, dialogButtonEditor) {

  /**
   * @class CustomButton
   */
  return function CustomButton (entry) {

    /** @private */
    var button = this;
    button.id = entry.id;
    if (!entry || !button.id) { return; }
    var imageElement, nameElement, categoryElement, descriptionElement;

    /**
     * @constructor
     */
    var initialize = function() {
      button.jQueryElement = $("<li/>").
        attr({"id": entry.id, "name": entry.id, "title": entry.name, "class": "toolbar-button"}).
        append(
          $("<div/>").attr("class", "controls").append(
            // Delete button
            $("<div/>").append(
              $("<button/>").attr("title", Translate.get("Delete")).addClass("symbolic-button").on("click", function() {
                $(button).trigger("delete");
                button.jQueryElement.remove();
                Bridge.call("delete_custom_button", entry.id);
              }).append(
                $("<img/>").attr({"src": "../images/icon_close.png"})
              )
            ),
            // Edit button
            $("<div/>").append(
              $("<button/>").attr("title", Translate.get("Edit")).addClass("symbolic-button").on("click", function() {
                dialogButtonEditor.show(function(entry) {
                  // Update the custom button.
                  imageElement.attr("src", entry.icon);
                  nameElement.text(entry.name);
                  categoryElement.text(entry.category);
                  descriptionElement.text(entry.description);
                }, entry);
              }).append(
                $("<img/>").attr({"src": "../images/icon_edit.png"})
              )
            )
          ),
          imageElement = $("<img/>").attr({"class": "icon", "src": entry.icon}),
          nameElement = $("<span/>").attr({"class": "name"}).text(entry.name),
          categoryElement = $("<span/>").attr({"class": "category"}).text(entry.category),
          descriptionElement = $("<span/>").attr({"class": "description"}).text(entry.description)
        );
    };


    initialize();
  };

});
